<?php
require("/www/cgi-bin/inc/head.inc");
require("/www/cgi-bin/inc/menu.inc");
include_once("/www/cgi-bin/inc/function.inc");
include_once("/www/cgi-bin/inc/wrcfg.inc");
include_once("/www/cgi-bin/inc/check.inc");
require_once("/www/cgi-bin/inc/aql.php");
?>

<!---// load jQuery and the jQuery iButton Plug-in //---> 
<!--<script type="text/javascript" src="http://ajax.googleapis.com/ajax/libs/jquery/1.3.2/jquery.min.js"></script> -->
<script type="text/javascript" src="/js/jquery.ibutton.js"></script> 
 
<!---// load the iButton CSS stylesheet //---> 
<link type="text/css" href="/css/jquery.ibutton.css" rel="stylesheet" media="all" />

<script type="text/javascript" src="/js/functions.js"></script>
<script type="text/javascript" src="/js/check.js"></script>
<script type="text/javascript">
<!--
function modechange()
{
	var tz_info = value('system_timezone');
	if ((tz_info=='') || (tz_info==null)){
		set_value('show_TZ', tz_info);
	}
	else {
		var tz_split = tz_info.split('@');
		set_value('show_TZ', tz_split[1]);
	}
}


function check()
{
	var ntp_server1 = document.getElementById("ntp_server1").value;
	var ntp_server2 = document.getElementById("ntp_server2").value;
	var ntp_server3 = document.getElementById("ntp_server3").value;

	document.getElementById("cntp_server1").innerHTML = '';
	if(ntp_server1 != '') {
		if(rstr=check_domain(ntp_server1)) {
			document.getElementById("cntp_server1").innerHTML = con_str(rstr);
			return false;
		} 
	}

	document.getElementById("cntp_server2").innerHTML = '';
	if(ntp_server1 != '') {
		if(rstr=check_domain(ntp_server1)) {
			document.getElementById("cntp_server2").innerHTML = con_str(rstr);
			return false;
		} 
	}

	document.getElementById("cntp_server2").innerHTML = '';
	if(ntp_server1 != '') {
		if(rstr=check_domain(ntp_server1)) {
			document.getElementById("cntp_server2").innerHTML = con_str(rstr);
			return false;
		} 
	}

	return true;
}


function postLocalTime()
{
	if(!check()) {
		return false;
	}

	var myDate = new Date();
	set_value('local_yea',myDate.getFullYear());
	set_value('local_mon',myDate.getMonth()+1);
	set_value('local_dat',myDate.getDate());
	set_value('local_hou',myDate.getHours());
	set_value('local_min',myDate.getMinutes());
	set_value('local_sec',myDate.getSeconds());

	return true;
}

-->
</script>

<?php
for($i=1; $i<=3; $i++) {
	$ntpserver[$i] = '';
}

function save_data()
{
	if( isset($_POST['ntp_server1']) &&
		isset($_POST['ntp_server2']) &&
		isset($_POST['ntp_server3']) &&
		isset($_POST['system_timezone']) &&
		isset($_POST['show_TZ'])
	) {
		global $ntpserver;

		for($i=1;$i<=3;$i++){
			$ntpserver[$i] = trim($_POST["ntp_server$i"]);
		}

		if(isset($_POST['auto_sw'])) {
			$auto = 'on';
		} else {
			$auto = 'off';
		}

		$timezone = trim($_POST['system_timezone']);
		$show_TZ = trim($_POST['show_TZ']);
		$file_path="/www/config/time.conf";
		$hlock=lock_file($file_path);
		$fh=fopen($file_path,"w");
		$write = "[general]\n";
		$write .= "auto_sync=$auto\n";
		$write .= "timezone=$timezone\n";
		for($i=1;$i<=3;$i++){
			$write .= "ntp$i=$ntpserver[$i]\n";
		}
		fwrite($fh,$write);
		fclose($fh);
		unlock_file($hlock);

		$tz_file_path="/etc/TZ";
		$hlock = lock_file($tz_file_path);
		$fh=fopen($tz_file_path,"w");
		fwrite($fh,"$show_TZ\n");
		fclose($fh);
		unlock_file($hlock);

		return true;
	}

	return false;
}

function sync_ntp()
{
	global $ntpserver;
	global $final_show;

	$final_show = '<font color=ff0000>Fail to synchronize from NTP server.</font>';

	for($i=1;$i<=3;$i++){
		if($ntpserver[$i] != '') {
			$ret = `/my_tools/ntpclient -h "$ntpserver[$i]" -s > /dev/null 2>&1 && echo -n 'ok'`;
			if($ret == 'ok') {
				$final_show = "Successfully synchronize from [ $ntpserver[$i] ].";
				return;
			}
		}
	}
}

function sync_client()
{
	global $final_show;
	$final_show = '<font color=ff0000>Fail to synchronize from client.</font>';

	if( isset($_POST['local_yea']) &&
		isset($_POST['local_mon']) &&
		isset($_POST['local_dat']) &&
		isset($_POST['local_hou']) &&
		isset($_POST['local_min']) &&
		isset($_POST['local_sec'])
	) {
		//date -s [MMDDhhmm[[CC]YY][.ss]]
		$ts = sprintf("%02d%02d%02d%02d%04d.%02d",$_POST['local_mon'],$_POST['local_dat'],$_POST['local_hou'],$_POST['local_min'],$_POST['local_yea'],$_POST['local_sec']);
		$cmd = "date -s \"$ts\"";
		$ret = `$cmd > /dev/null 2>&1 && echo -n 'ok'`;
		if($ret == 'ok') {
			$final_show = "Successfully synchronize from client.";
		}
	}
}

if($_POST && isset($_POST['send'])) {
	if($_POST['send'] == 'Sync from NTP') {
		if(save_data()) {
			sync_ntp();
		}
	} else if($_POST['send'] == 'Sync from Client') {
		if(save_data()) {
			sync_client();
		}
	}
}

//Read data 
$aql = new aql();
$aql->set('basedir','/www/config');
$res = $aql->query('select * from time.conf');

if(isset($res['general']['timezone'])) {
	$cf_timezone = trim($res['general']['timezone']);
} else {
	$cf_timezone = '-@UTC+0';
}

$auto_sw = '';
if(isset($res['general']['auto_sync'])) {
	$val = trim($res['general']['auto_sync']);
	if(strcasecmp($val,'on') == 0) {
		$auto_sw = 'checked';
	}
}

for($i=1;$i<=3;$i++){
	if(isset($res['general']["ntp$i"])) {
		$cf_ntp[$i] = trim($res['general']["ntp$i"]);
	} else {
		$cf_ntp[$i] = '';
	}
}

?>

	<form enctype="multipart/form-data" action="<?php echo $_SERVER['PHP_SELF'] ?>" method="post">

	<div id="tab">
		<li class="tb1">&nbsp;</li>
		<li class="tbg">Time Settings</li>
		<li class="tb2">&nbsp;</li>
	</div>

	<table width="100%" class="tedit" >
		<tr>
			<th>
				<div class="helptooltips">
					System Time:
					<span class="showhelp">
						Your gateway system time.
					</span>
				</div>
			</th>
			<td>
				<span id="currenttime"></span>
			</td>
		</tr>
		<tr>
			<th>
				<div class="helptooltips">
					Time Zone:
					<span class="showhelp">
						The world time zone.Please select the one which is the same or the closest as your city.
					</span>
				</div>
			</th>
			<td>
				<select id="system_timezone" style="width: 253px;" name="system_timezone" onchange="modechange(this)">
					<optgroup label="Australia">
						<option  value="Australia/Melbourne@EST-10EST,M10.5.0,M3.5.0/3">Melbourne,Canberra,Sydney</option>
						<option  value="Australia/Perth@WST-8">Perth</option>
						<option  value="Australia/Brisbane@EST-10">Brisbane</option>
						<option  value="Australia/Adelaide@CST-9:30CST,M10.5.0,M3.5.0/3">Adelaide</option>
						<option  value="Australia/Darwin@CST-9:30">Darwin</option>
						<option  value="Australia/Hobart@EST-10EST,M10.1.0,M3.5.0/3">Hobart</option>
					</optgroup>
					<optgroup label="Europe">
						<option  value="Europe/Amsterdam@CET-1CEST,M3.5.0,M10.5.0/3">Amsterdam,Netherlands</option>
						<option  value="Europe/Athens@EET-2EEST,M3.5.0/3,M10.5.0/4">Athens,Greece</option>
						<option  value="Europe/Berlin@CET-1CEST,M3.5.0,M10.5.0/3">Berlin,Germany</option>
						<option  value="Europe/Brussels@CET-1CEST,M3.5.0,M10.5.0/3">Brussels,Belgium</option>
						<option  value="Europe/Bratislava@CET-1CEST,M3.5.0,M10.5.0/3">Bratislava,Slovakia</option>
						<option  value="Europe/Budapest@CET-1CEST,M3.5.0,M10.5.0/3">Budapest,Hungary</option>
						<option  value="Europe/Copenhagen@CET-1CEST,M3.5.0,M10.5.0/3">Copenhagen,Denmark</option>
						<option  value="Europe/Dublin@GMT0IST,M3.5.0/1,M10.5.0">Dublin,Ireland</option>
						<option  value="Europe/Helsinki@EET-2EEST,M3.5.0/3,M10.5.0/4">Helsinki,Finland</option>
						<option  value="Europe/Kiev@EET-2EEST,M3.5.0/3,M10.5.0/4">Kyiv,Ukraine</option>
						<option  value="Europe/Lisbon@WET0WEST,M3.5.0/1,M10.5.0">Lisbon,Portugal</option>
						<option  value="Europe/London@GMT0BST,M3.5.0/1,M10.5.0">London,GreatBritain</option>
						<option  value="Europe/Madrid@CET-1CEST,M3.5.0,M10.5.0/3">Madrid,Spain</option>
						<option  value="Europe/Oslo@CET-1CEST,M3.5.0,M10.5.0/3">Oslo,Norway</option>
						<option  value="Europe/Paris@CET-1CEST,M3.5.0,M10.5.0/3">Paris,France</option>
						<option  value="Europe/Prague@CET-1CEST,M3.5.0,M10.5.0/3">Prague,CzechRepublic</option>
						<option  value="Europe/Rome@CET-1CEST,M3.5.0,M10.5.0/3">Roma,Italy</option>
						<option  value="Europe/Moscow@MSK-3MSD,M3.5.0,M10.5.0/3">Moscow,Russia</option>
						<option  value="Europe/Stockholm@CET-1CEST,M3.5.0,M10.5.0/3">Stockholm,Sweden</option>
						<option  value="Europe/Zurich@CET-1CEST,M3.5.0,M10.5.0/3">Zurich,Switzerland</option>
					</optgroup>
					<optgroup label="New Zealand">
						<option  value="Pacific/Auckland@NZST-12NZDT,M10.1.0,M3.3.0/3">Auckland, Wellington</option>
					</optgroup>
					<optgroup label="USA &amp; Canada">
						<option  value="Pacific/Honolulu@HST10">Hawaii Time</option>
						<option  value="America/Anchorage@AKST9AKDT,M3.2.0,M11.1.0">Alaska Time</option>
						<option  value="America/Los_Angeles@PST8PDT,M3.2.0,M11.1.0">Pacific Time</option>
						<option  value="America/Denver@MST7MDT,M3.2.0,M11.1.0">Mountain Time</option>
						<option  value="America/Phoenix@MST7">Mountain Time (Arizona, no DST)</option>
						<option  value="America/Chicago@CST6CDT,M3.2.0,M11.1.0">Central Time</option>
						<option  value="America/New_York@EST5EDT,M3.2.0,M11.1.0">Eastern Time</option>
					</optgroup>
					<optgroup label="Atlantic">
						<option  value="Atlantic/Bermuda@AST4ADT,M3.2.0,M11.1.0">Bermuda</option>
					</optgroup>
					<optgroup label="Asia (UTC+1)">
						<option  value="Asia/Anadyr@ANAT-12ANAST,M3.5.0,M10.5.0/3">Anadyr</option>
					</optgroup>
					<optgroup label="Asia (UTC+2)">
						<option  value="Asia/Amman@EET-2EEST,M3.5.4/0,M10.5.5/1">Amman</option>
						<option  value="Asia/Beirut@EET-2EEST,M3.5.0/0,M10.5.0/0">Beirut</option>
						<option  value="Asia/Damascus@EET-2EEST,J91/0,J274/0">Damascus</option>
						<option  value="Asia/Gaza@EET-2EEST,J91/0,M10.3.5/0">Gaza</option>
						<option  value="Asia/Jerusalem@GMT-2">Jerusalem</option>
						<option  value="Asia/Nicosia@EET-2EEST,M3.5.0/3,M10.5.0/4">Nicosia</option>
					</optgroup>
					<optgroup label="Asia (UTC+3)">
						<option  value="Asia/Aden@AST-3">Aden</option>
						<option  value="Asia/Baghdad@AST-3ADT,J91/3,J274/4">Baghdad</option>
						<option  value="Asia/Bahrain@AST-3">Bahrain</option>
						<option  value="Asia/Kuwait@AST-3">Kuwait</option>
						<option  value="Asia/Qatar@AST-3">Qatar</option>
						<option  value="Asia/Riyadh@AST-3">Riyadh</option>
					</optgroup>
					<optgroup label="Asia (UTC+3:30)">
						<option  value="Asia/Tehran@IRST-3:30">Tehran</option>
					</optgroup>
					<optgroup label="Asia (UTC+4)">
						<option  value="Asia/Baku@AZT-4AZST,M3.5.0/4,M10.5.0/5">Baku</option>
						<option  value="Asia/Dubai@GST-4">Dubai</option>
						<option  value="Asia/Muscat@GST-4">Muscat</option>
						<option  value="Asia/Tbilisi@GET-4">Tbilisi</option>
						<option  value="Asia/Yerevan@AMT-4AMST,M3.5.0,M10.5.0/3">Yerevan</option>
					</optgroup>
					<optgroup label="Asia (UTC+4:30)">
						<option  value="Asia/Kabul@AFT-4:30">Kabul</option>
					</optgroup>
					<optgroup label="Asia (UTC+5)">
						<option  value="Asia/Aqtobe@AQTT-5">Aqtobe</option>
						<option  value="Asia/Ashgabat@TMT-5">Ashgabat</option>
						<option  value="Asia/Dushanbe@TJT-5">Dushanbe</option>
						<option  value="Asia/Karachi@PKT-5">Karachi</option>
						<option  value="Asia/Oral@ORAT-5">Oral</option>
						<option  value="Asia/Samarkand@UZT-5">Samarkand</option>
						<option  value="Asia/Tashkent@UZT-5">Tashkent</option>
						<option  value="Asia/Yekaterinburg@YEKT-5YEKST,M3.5.0,M10.5.0/3">Yekaterinburg</option>
					</optgroup>
					<optgroup label="Asia (UTC+5:30)">
						<option  value="Asia/Calcutta@IST-5:30">Calcutta</option>
						<option  value="Asia/Colombo@IST-5:30">Colombo</option>
					</optgroup>
					<optgroup label="Asia (UTC+6)">
						<option  value="Asia/Almaty@ALMT-6">Almaty</option>
						<option  value="Asia/Bishkek@KGT-6">Bishkek</option>
						<option  value="Asia/Dhaka@BDT-6">Dhaka</option>
						<option  value="Asia/Novosibirsk@NOVT-6NOVST,M3.5.0,M10.5.0/3">Novosibirsk</option>
						<option  value="Asia/Omsk@OMST-6OMSST,M3.5.0,M10.5.0/3">Omsk</option>
						<option  value="Asia/Qyzylorda@QYZT-6">Qyzylorda</option>
						<option  value="Asia/Thimphu@BTT-6">Thimphu</option>
					</optgroup>
						<optgroup label="Asia (UTC+7)">
						<option  value="Asia/Jakarta@WIT-7">Jakarta</option>
						<option  value="Asia/Bangkok@ICT-7">Bangkok</option>
						<option  value="Asia/Vientiane@ICT-7">Vientiane</option>
						<option  value="Asia/Phnom_Penh@ICT-7">Phnom Penh</option>
					</optgroup>
					<optgroup label="Asia (UTC+8)">
						<option  value="Asia/Chongqing@CST-8">Chongqing</option>
						<option  value="Asia/Hong_Kong@HKT-8">Hong Kong</option>
						<option  value="Asia/Shanghai@CST-8">Shanghai</option>
						<option  value="Asia/Singapore@SGT-8">Singapore</option>
						<option  value="Asia/Urumqi@CST-8">Urumqi</option>
						<option  value="Asia/Taipei@CST-8">Taiwan</option>
						<option  value="Asia/Ulaanbaatar@ULAT-8">Ulaanbaatar</option>
					</optgroup>
					<optgroup label="Asia (UTC+9)">
						<option  value="Asia/Dili@TLT-9">Dili</option>
						<option  value="Asia/Jayapura@EIT-9">Jayapura</option>
						<option  value="Asia/Pyongyang@KST-9">Pyongyang</option>
						<option  value="Asia/Seoul@KST-9">Seoul</option>
						<option  value="Asia/Tokyo@JST-9">Tokyo</option>
						<option  value="Asia/Yakutsk@YAKT-9YAKST,M3.5.0,M10.5.0/3">Yakutsk</option>
					</optgroup>
					<optgroup label="Central and South America">
						<option  value="America/Sao_Paulo@BRT3BRST,M11.1.0/0,M2.5.0/0">Sao Paulo,Brazil</option>
						<option  value="America/Argentina/Buenos_Aires@ART3">Argentina</option>
						<option  value="America/Guatemala@CST6">Central America (no DST)</option>
					</optgroup>
					<optgroup label="Unknown">
						<option value="-@UTC+0">User defined (or out of date)</option>
					</optgroup>
				</select>							
			</td>
		</tr>
		<tr>
			<th>
				<div class="helptooltips">
					POSIX TZ String:
					<span class="showhelp">
					Posix timezone strings.
					</span>
				</div>
			</th>
			<td>
				<input id="show_TZ" type="text" style="width: 250px; height: 1.2em; color: #2f2f2f; background: #ececec; " name="show_TZ" readonly="readonly" value="This field requires the JavaScript support." />
			</td>
		</tr>

<?php
		$help_str[1]='Time server domain or hostname.For example, [time.asia.apple.com]';
		$help_str[2]='The first reserved NTP server.For example, [time.windows.com]';
		$help_str[3]='The second reserved NTP server.For example, [time.nist.gov]';
		for($i=1; $i<=3; $i++) {
			echo "<tr>\n";
			echo "<th>\n";
			echo "<div class=\"helptooltips\">\n";
			echo "NTP Server $i:";
			echo "<span class=\"showhelp\">\n";
			echo $help_str[$i];
			echo "</span>\n";
			echo "</div>\n";
			echo "</th>\n";
			echo "<td>\n";
			echo "<input id=\"ntp_server${i}\" type=\"text\" name=\"ntp_server${i}\" style=\"width: 250px;\" value=\"$cf_ntp[$i]\" />"; 
			echo "<span id=\"cntp_server${i}\"></span>\n";
			echo "</td>\n";
			echo "</tr>\n";
		}
?>
		<tr>
			<th>
				<div class="helptooltips">
					Auto-Sync from NTP:
					<span class="showhelp">
						Whether enable automatically synchronize from NTP server or not. On(enabled),OFF(disabled).
					</span>
				</div>
			</th>
			<td>
				<input type="checkbox" id="auto_sw" name="auto_sw" <?php echo $auto_sw?>  />
			</td>
		</tr>
	</table>
	<br>
	<input type="hidden" name="local_yea" id="local_yea" value="" />
	<input type="hidden" name="local_mon" id="local_mon" value="" />
	<input type="hidden" name="local_dat" id="local_dat" value="" />
	<input type="hidden" name="local_hou" id="local_hou" value="" />
	<input type="hidden" name="local_min" id="local_min" value="" />
	<input type="hidden" name="local_sec" id="local_sec" value="" />

	<input type="submit" name="send" value="Sync from NTP" onclick="return check();"/>
	<input type="submit" name="send" value="Sync from Client" onclick="return postLocalTime();"/>
	</form>
	<br>

<script type="text/javascript"> 
$(document).ready(function (){ 
  $(":checkbox").iButton(); 
}); 
</script>

<?php
	if(isset($final_show) && $final_show != "") {
		echo "<br>";
		echo $final_show;
	}
 ?>

<?php
	//date_default_timezone_set("6"+readfile("/etc/TZ"));
	$all_time = `date "+%Y:%m:%d:%H:%M:%S"`;
	$item = explode(':', $all_time, 6);
	if(isset($item[5])) {
		$year = $item[0];
		$month = $item[1];
		$date = $item[2];
		$hour = $item[3];
		$minute = $item[4];
		$second = $item[5];
	}
?>

<script type="text/javascript">
<!--
var c=0;
var Y=<?php echo $year?>;
var M=<?php echo $month?>;
var D=<?php echo $date?>;
var sec=<?php echo $hour*3600+$minute*60+$second?>;
function ctime() {
	sec++;
	H=Math.floor(sec/3600)%24;
	I=Math.floor(sec/60)%60;
	S=sec%60;
	if(S<10) S='0'+S;
	if(I<10) I='0'+I;
	if(H<10) H='0'+H;
	if (H=='00' & I=='00' & S=='00') D=D+1; //սλ
	if (M==2) { //жǷΪ·******
		if (Y%4==0 && !Y%100==0 || Y%400==0) { //(28)
			if (D==30){
				M+=1;D=1;
			} //·ݽλ
		} else { //(29)
			if (D==29) {
				M+=1;D=1;
			} //·ݽλ
		}
	} else { //Ƕ·ݵ·******
		if (M==4 || M==6 || M==9 || M==11) { //С(30)
			if (D==31) {
				M+=1;D=1;
			} //·ݽλ
		} else { //(31)
			if (D==32) {
				M+=1;D=1;
			} //·ݽλ
		}
	}

	if (M==13) {
		Y+=1;M=1;
	} //ݽλ

	//setInterval(ctime,1000);
	setTimeout("ctime()", 1000);
//	set_value('cur_time', 'ada');
//	document.system_time.cur_time.value = Y+'-'+M+'-'+D+' '+H+':'+I+':'+S;
	document.getElementById("currenttime").innerHTML = Y+'-'+M+'-'+D+' '+H+':'+I+':'+S;
}

function onload_func()
{
	modechange();
	ctime();
}

document.getElementById("system_timezone").value = "<?php echo $cf_timezone; ?>";
document.body.onload = onload_func;
-->
</script>

<?php require("/www/cgi-bin/inc/boot.inc");?>